/*
 *     SimpleTestDDG.java  Sep 25, 2001
 *
 *     Katsuhisa Maruyama (maru@fse.cs.ritsumei.ac.jp)
 */

import jp.ac.ritsumei.cs.fse.jrt.graphs.pdg.*;
import jp.ac.ritsumei.cs.fse.jrt.graphs.GraphFactory;
import jp.ac.ritsumei.cs.fse.jrt.parser.JavaModelFactory;
import jp.ac.ritsumei.cs.fse.jrt.parser.summary.Summary;
import jp.ac.ritsumei.cs.fse.jrt.model.*;
import java.util.Iterator;
import java.io.File;

public class SimpleTestDDG {
    private static JavaFile jfile;

    public static void main(String args[]) {
        if (args.length == 1) {
            String fileName = args[0];

            String dirName = ".";
            if (fileName.indexOf(File.separator) != -1) {
                dirName = fileName.substring(0, fileName.lastIndexOf(File.separator));
            }

            String JDKFilePath;
            if (System.getProperty("os.name").startsWith("Windows")) {
                JDKFilePath = "c:\\jdk1.3.1\\src.jar";
            } else {
                JDKFilePath = "/usr/local/j2sdk1_3_1/src.jar";
            }
            JavaModelFactory.getInstance().setJDKFile(JDKFilePath);
            Summary.getInstance().parse(dirName);

            jfile = JavaModelFactory.getInstance().getJavaFile(fileName);
            // jfile = JavaModelFactory.getInstance().getEachJavaFile(fileName);

            if (jfile != null) {
                GraphFactory.getInstance().makeCFG(jfile);
                GraphFactory.getInstance().makePDG(jfile);

                printPDG(jfile);
            }
        } else {
            System.err.println("Usage: java jp.ac.ritsumei.cs.fse.jrt.model.SimpleTest inputfile");
            return;
        }
    }

    private static void printPDG(JavaFile jfile) {
        Iterator it = jfile.getJavaClasses().iterator();
        while (it.hasNext()) {
            JavaClass jclass = (JavaClass)it.next();
            printClDG(jclass);
        }
    }

    private static void printClDG(JavaClass jclass) {
        Iterator it = jclass.getJavaMethods().iterator();
        while (it.hasNext()) {
            JavaMethod jmethod = (JavaMethod)it.next();
            PDG pdg = (PDG)jmethod.getPDG();
            pdg.printDDG();
        }
    }
}
