/*
 *     MoveFieldTest.java  Dec 21, 2001
 *
 *     Katsuhisa Maruyama (maru@fse.cs.ritsumei.ac.jp)
 */

import jp.ac.ritsumei.cs.fse.jrt.refactor.fields.*;
import jp.ac.ritsumei.cs.fse.jrt.refactor.util.test.RefactoringTest;
import jp.ac.ritsumei.cs.fse.jrt.refactor.Refactoring;
import jp.ac.ritsumei.cs.fse.jrt.refactor.util.*;
import jp.ac.ritsumei.cs.fse.jrt.model.*;
import jp.ac.ritsumei.cs.fse.jrt.parser.summary.Summary;
import javax.swing.JFrame;

public class MoveFieldTest extends RefactoringTest {

    public static void main(String args[]) {
        if (args.length >= 3) {
            String dir = ".";
            Summary.getInstance().parse(dir);

            JavaFile jfile = doParse(args[0]);
            JavaComponent jc = getJC(jfile, args[1], args[2]);

            JFrame f = new JFrame();
            f.setVisible(true);

            if (jc instanceof JavaVariable) {
                JavaVariable jv = (JavaVariable)jc;
                JavaStatement jst = jv.getJavaClass().getJavaField(jv);

                JavaVariable jfield = jst.getDeclaration();

                Refactoring refactoring;
                if (args.length == 3) {
                    refactoring = new MoveField(f, jfield, dir, null);
                } else {
                    refactoring = new MoveField(f, jfield, dir, args[3]);
                }
                refactoring.execute();
            }
            System.exit(0);
        } else {
            System.err.println("Usage: MoveFieldTest inputfile line column [dst_classname]");
            return;
        }
    }
}
