/*
 *     PullUpFieldTest.java  Dec 21, 2001
 *
 *     Katsuhisa Maruyama (maru@fse.cs.ritsumei.ac.jp)
 */

import jp.ac.ritsumei.cs.fse.jrt.refactor.fields.*;
import jp.ac.ritsumei.cs.fse.jrt.refactor.util.test.RefactoringTest;
import jp.ac.ritsumei.cs.fse.jrt.refactor.Refactoring;
import jp.ac.ritsumei.cs.fse.jrt.refactor.util.*;
import jp.ac.ritsumei.cs.fse.jrt.model.*;
import jp.ac.ritsumei.cs.fse.jrt.parser.summary.Summary;
import java.io.*;
import javax.swing.JFrame;

public class PullUpFieldTest extends RefactoringTest {

    public static void main(String args[]) {
        if (args.length == 3) {
            String dir = ".";
            Summary.getInstance().parse(dir);

            JavaFile jfile = doParse(args[0]);
            JavaComponent jc = getJC(jfile, args[1], args[2]);

            JFrame f = new JFrame();
            f.setVisible(true);

            if (jc instanceof JavaVariable) {
                JavaVariable jv = (JavaVariable)jc;
                JavaStatement jst = jv.getJavaClass().getJavaField(jv);

                JavaVariable jfield = jst.getDeclaration();
                Refactoring refactoring = new PullUpField(f, jfield, dir);
                refactoring.execute();
            }
            System.exit(0);
        } else {
            System.err.println("Usage: PullUpFieldTest inputfile line column");
            return;
        }
    }
}
