/*
 *     SplitVariableTest.java  Apr 10, 2003
 *
 *     Katsuhisa Maruyama (maru@fse.cs.ritsumei.ac.jp)
 */

import jp.ac.ritsumei.cs.fse.jrt.refactor.variables.*;
import jp.ac.ritsumei.cs.fse.jrt.refactor.util.test.RefactoringTest;
import jp.ac.ritsumei.cs.fse.jrt.refactor.Refactoring;
import jp.ac.ritsumei.cs.fse.jrt.refactor.util.*;
import jp.ac.ritsumei.cs.fse.jrt.model.*;
import jp.ac.ritsumei.cs.fse.jrt.parser.summary.Summary;
import javax.swing.JFrame;

public class SplitVariableTest extends RefactoringTest {

    public static void main(String args[]) {
        if (args.length >= 3) {
            String dir = ".";
            Summary.getInstance().parse(dir);

            JavaFile jfile = doParse(args[0]);
            JavaComponent jc = getJC(jfile, args[1], args[2]);

            JFrame f = new JFrame();
            f.setVisible(true);

            if (jc != null && jc.isJavaVariable()) {
                JavaVariable jvar = (JavaVariable)jc;

                Refactoring refactoring;
                if (args.length == 3) {
                    refactoring = new SplitVariable(f, jvar, dir, null);
                } else {
                    refactoring = new SplitVariable(f, jvar, dir, args[3]);
                }
                refactoring.execute();
            }
            System.exit(0);
        } else {
            System.err.println("Usage: SplitVariableTest inputfile line column [new_name]");
            return;
        }
    }
}
